LeetCode OJ算法题(五十九):Permutation Sequence

题目:

The set [1,2,3,…,n] contains a total of n! unique permutations.

By listing and labeling all of the permutations in order,
We get the following sequence (ie, for n = 3):

  1. "123"
  2. "132"
  3. "213"
  4. "231"
  5. "312"
  6. "321"

Given n and k, return the kth permutation sequence.

Note: Given n will be between 1 and 9 inclusive.

解法:

要求生成第k个排列,第一感觉是使用next Permutation的方法,调用k次,但是这样感觉开销太大,应该可以直接通过k和n算出结果的。

观察第一位的数字,如果k<(n-1)!那么该位肯定是1,如果k在n-1的阶乘和2倍的n-1的阶乘之间,那么该位为2,以此类推,因此可以用(k-1)/(n-1)!来判断第一位是多少,然后递归产生第二位,第三位。。。但是注意元素只能使用一次,因此我用了HashSet来保存使用过的数字。

import java.util.HashSet;


public class No59_PermutationSequence {
	public static void main(String[] args){
		System.out.println(getPermutation(3, 1));
	}
	public static String getPermutation(int n, int k) {
        if(k > factorial(n)) return "";
        HashSet<Integer> set = new HashSet<Integer>();
        return getP(n, k, set);
    }
	public static String getP(int n, int k, HashSet<Integer> set){
		if(n == 1){
			int r = 1;
			while(set.contains(r))
				r++;
			return ""+r;
		} 
		int tmp = factorial(n-1);
		int first = 0;
		int i = 0;
		do{
			first++;
			while(set.contains(first)) first++;
			i++;
		}while(i <= (k-1)/tmp);
		set.add(first);
		return ""+first+getP(n-1, k%tmp==0?tmp:k%tmp, set);
	}
	public static int factorial(int n){
		if(n==0 || n==1) return 1;
		return factorial(n-1) * n;
	}
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值